'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = apply;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合の要素を、指定した関数の引数に割り当てて呼び出します。foo(x, y)をargs = [1, 2]で呼び出す場合に、apply(foo, args)としてください。
 *
 * @param {function} f - 関数
 * @param {*[] | iterator | null} args - 関数の引数の集合
 *
 * @return {*} 関数fの戻り値
 *
 * @example
 * apply(foo, args);
 * // = foo(...args);
 *
 * @example
 * filter(partial(apply, foo), [[1, 2], [3, 4]]);
 * // = filter(args => foo(...args), [[1, 2], [3, 4]]);
 */
function apply(f, args) {
  return f(...(0, _sequence2.default)(args));
}