'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = butlast;

var _seq = require('./seq');

var _seq2 = _interopRequireDefault(_seq);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 最後の要素を除いた集合のイテレーターを返します。
 *
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator | null} 最後の要素を除いた集合のイテレーター
 */
function butlast(coll) {
  return (0, _seq2.default)(function* () {
    const iter = (0, _seq2.default)(coll);
    if (!iter) {
      return;
    }

    let prev = iter.next().value;

    for (const x of iter) {
      yield prev;

      prev = x;
    }
  }());
}