'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = comp;

var _pipe = require('./pipe');

var _pipe2 = _interopRequireDefault(_pipe);

var _reverse = require('./reverse');

var _reverse2 = _interopRequireDefault(_reverse);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 関数を合成します。
 *
 * @param {function[] | iterator} fs - 合成したい関数の集合
 *
 * @return {function} 合成された関数。
 *
 * @example
 * comp(foo, bar);
 * // = x => foo(bar(x));
 */
function comp(...fs) {
  return (0, _pipe2.default)(...(0, _reverse2.default)(fs));
}