'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = concat;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 複数の集合を結合します。
 *
 * @param {*[][] | iterator[]} xss - 結合したい集合の集合
 *
 * @return {iterator} 結合された集合のイテレーター
 *
 * @example
 * concat([1, 2, 3], [4, 5, 6]);  // [1, 2, 3, 4, 5, 6]のイテレーターを返す
 */
function* concat(...xss) {
  for (const xs of xss) {
    for (const x of (0, _sequence2.default)(xs)) {
      yield x;
    }
  }
}