'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = conj;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合の最後に要素を追加し、イテレーターを返します。Clojureのconjとは異なり、コレクションではなくイテレーターを返します。
 *
 * @param {*[] | iterator | null} coll - 集合
 * @param {*} x - 追加する要素
 *
 * @return {iterator} 最後に要素が追加された集合のイテレーター
 */
function* conj(coll, x) {
  for (const y of (0, _sequence2.default)(coll)) {
    yield y;
  }

  yield x;
}