'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = distinct;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合から重複した要素を削除したイテレーターを返します。
 *
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator} 重複した要素が削除された集合のイテレーター
 *
 * @example
 * distinct([1, 2, 3, 3, 3, 1, 1, 4]);  // [1, 2, 3, 4]のイテレーター
 */
function* distinct(coll) {
  const seen = new Set();

  for (const x of (0, _sequence2.default)(coll)) {
    if (!seen.has(x)) {
      seen.add(x);

      yield x;
    }
  }
}