'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = drop;

var _nthrest = require('./nthrest');

var _nthrest2 = _interopRequireDefault(_nthrest);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合から先頭n個の要素を削除したイテレーターを返します。
 *
 * @param {number} n - 削除する要素の数
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator} 先頭n個の要素が削除された集合のイテレーター
 *
 * @example
 * drop(2, range());  // [2, 3, 4, ...]のイテレーター
 */
function drop(n, coll) {
  return (0, _nthrest2.default)(coll, n);
}