'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = every;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合のすべての要素が条件を満たすか確認します。
 *
 * @param {function} pred - 条件
 * @param {*[] | iterator | null } coll - 集合
 *
 * @return {boolean} すべての要素が条件を満たす場合はtrue、そうでなければfalse
 */
function every(pred, coll) {
  for (const x of (0, _sequence2.default)(coll)) {
    if (!pred(x)) {
      return false;
    }
  }

  return true;
}