'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = first;

var _seq = require('./seq');

var _seq2 = _interopRequireDefault(_seq);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合の最初の要素を返します。
 *
 * @param {*[] | iterator} coll - 集合
 *
 * @return {*} 最初の要素
 */
function first(coll) {
  const iter = (0, _seq2.default)(coll);
  if (!iter) {
    return null;
  }

  return iter.next().value;
}