'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = flatten;

var _isSequencial = require('./isSequencial');

var _isSequencial2 = _interopRequireDefault(_isSequencial);

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合の集合を集合に変換し、そのイテレーターを返します。
 *
 * @param {*[][] | iterator | null} coll - 集合の集合
 *
 * @return 集合のイテレーター
 *
 * @example
 * flatten([1, 2, [3, 4, [5, 6], 7], 8]);  // [1, 2, 3, 4, 5, 6, 7, 8]のイテレーター
 */
function flatten(coll) {
  if (!(0, _isSequencial2.default)(coll)) {
    return (0, _sequence2.default)(null);
  }

  const _ = function* (x) {
    for (const y of x) {
      if (!(0, _isSequencial2.default)(y)) {
        yield y;
      } else {
        for (const z of _(y)) {
          yield z;
        }
      }
    }
  };

  return _(coll);
}