'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = keepIndexed;

var _apply = require('./apply');

var _apply2 = _interopRequireDefault(_apply);

var _keep = require('./keep');

var _keep2 = _interopRequireDefault(_keep);

var _map = require('./map');

var _map2 = _interopRequireDefault(_map);

var _partial = require('./partial');

var _partial2 = _interopRequireDefault(_partial);

var _range = require('./range');

var _range2 = _interopRequireDefault(_range);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * インデックスと集合の要素を引数に取る関数を実行した結果がnullでない場合の集合のイテレーターを返します。
 *
 * @param {function} f - インデックスと集合の要素を引数に取る関数
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator} 関数の実行結果がnullでない場合の集合のイテレーター
 *
 * @example
 * keepIndexed((i, x) => x > 0 ? i : null, [-9 0 29 -7 45 3 -8]);  // [2, 4, 5]のイテレーター
 */
function keepIndexed(f, coll) {
  return (0, _keep2.default)((0, _partial2.default)(_apply2.default, f), (0, _map2.default)((i, x) => [i, x], (0, _range2.default)(), coll));
}