'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = last;

var _seq = require('./seq');

var _seq2 = _interopRequireDefault(_seq);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合の最後の要素を返します。
 *
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {*} 集合の最後の要素
 */
function last(coll) {
  const iter = (0, _seq2.default)(coll);
  if (!iter) {
    return null;
  }

  let prev = iter.next().value;
  for (const x of iter) {
    prev = x;
  }

  return prev;
}