'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = map;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

var _some = require('./some');

var _some2 = _interopRequireDefault(_some);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function* map(f, ...colls) {
  if (colls.length === 1) {
    for (const x of colls[0]) {
      yield f(x);
    }
  } else {
    const iters = colls.map(_sequence2.default);

    for (;;) {
      const nexts = iters.map(iter => iter.next());
      if (nexts.some(next => next.done)) {
        break;
      }

      yield f(...nexts.map(next => next.value));
    }
  }
}