'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mapIndexed;

var _map = require('./map');

var _map2 = _interopRequireDefault(_map);

var _range = require('./range');

var _range2 = _interopRequireDefault(_range);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * インデックスと集合の要素を引数に取る関数を実行した結果の集合のイテレーターを返します。map(f, range(), coll)と同じです。
 *
 * @param {function} f - インデックスと集合の要素を引数に取る関数
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator} 関数の実行結果の集合のイテレーター
 *
 * @example
 * map((i, e) => [i, e.favoriteLanguage()], getEmployees());  // インデックスと好きな言語の配列のシーケンス
 */
function mapIndexed(f, coll) {
  return (0, _map2.default)(f, (0, _range2.default)(), coll);
}