'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mapcat;

var _apply = require('./apply');

var _apply2 = _interopRequireDefault(_apply);

var _concat = require('./concat');

var _concat2 = _interopRequireDefault(_concat);

var _map = require('./map');

var _map2 = _interopRequireDefault(_map);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * mapした結果をconcatします。apply(concat, map(f, coll))と同じです。
 *
 * @param {function} f - 集合の要素に対して実行する関数
 * @param {*[][] | iterator[]} colls - 集合
 *
 * @return {iterator} 関数の戻り値をconcatした集合のイテレーター
 *
 * @example
 * mapcat(e => e.canUseLanguages(), getEmployees());  // 社員が使用できる言語の集合。イテレーターのイテレーターにならずに、イテレーターになります
 */
function mapcat(f, ...colls) {
  return (0, _apply2.default)(_concat2.default, (0, _map2.default)(f, ...colls));
}