'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = max;

var _rest = require('./rest');

var _rest2 = _interopRequireDefault(_rest);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 引数の中で最大の値を返します。
 *
 * @param {*[]} xs - 値の集合
 *
 * @return {*} 最大の値
 */
function max(...xs) {
  if (xs.length === 0) {
    throw 'Invalid arguments';
  }

  let max = xs[0];

  for (const x of (0, _rest2.default)(xs)) {
    if (x > max) {
      max = x;
    }
  }

  return max;
}