'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = min;

var _rest = require('./rest');

var _rest2 = _interopRequireDefault(_rest);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 引数の中で最小の値を返します。
 *
 * @param {*[]} xs - 値の集合
 *
 * @return {*} 最小の値
 */
function min(...xs) {
  if (xs.length === 0) {
    throw 'Invalid arguments';
  }

  let min = xs[0];

  for (const x of (0, _rest2.default)(xs)) {
    if (x < min) {
      min = x;
    }
  }

  return min;
}