'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = notEvery;

var _every = require('./every');

var _every2 = _interopRequireDefault(_every);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合の要素の中に、条件を満たさないものがあるか確認します。everyの反対です。
 *
 * @param {function} pred - 条件
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {boolean} 条件を満たさないものがあればtrue、そうでなければfalse
 */
function notEvery(pred, coll) {
  return !(0, _every2.default)(pred, coll);
}