'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = nth;

var _seq = require('./seq');

var _seq2 = _interopRequireDefault(_seq);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合のn番目の要素を取得します。
 *
 * @param {*[] | iterator | null} coll - 集合
 * @param {number} n - 何番目の要素を取得したいか
 *
 * @return {* | null} n番目の要素。要素が存在しない場合はnull
 */
function nth(coll, n) {
  const iter = (0, _seq2.default)(coll);
  if (!iter) {
    return null;
  }

  let next = undefined;
  for (let i = 0; i <= n; ++i) {
    next = iter.next();
    if (next.done) {
      return null;
    }
  }

  return next.value;
}