'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = nthnext;

var _seq = require('./seq');

var _seq2 = _interopRequireDefault(_seq);

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合のn番目以降のイテレーターを返します。
 *
 * @param {*[] | iterator | null} coll - 集合
 * @param {number} n - 何番目以降のデータを取得するか
 *
 * @return {iterator | null} 集合のn番目以降のイテレーター。集合の要素数がnよりも小さい場合はnull
 */
function nthnext(coll, n) {
  const iter = (0, _sequence2.default)(coll);

  for (let i = 0; i < n; ++i) {
    const next = iter.next();
    if (next.done) {
      return null;
    }
  }

  return (0, _seq2.default)(iter);
}