'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = nthrest;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合のn番目以降のイテレーターを返します。
 *
 * @param {*[] | iterator | null} coll - 集合
 * @param {number} n - 何番目以降のデータを取得するか
 *
 * @return {iterator | null} 集合のn番目以降のイテレーター
 */
function nthrest(coll, n) {
  const iter = (0, _sequence2.default)(coll);

  for (let i = 0; i < n; ++i) {
    const next = iter.next();
    if (next.done) {
      return (0, _sequence2.default)(null);
    }
  }

  return iter;
}