'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = randNth;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 要素を1つランダムに抽出します。
 *
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {*} ランダムに抽出された要素
 */
function randNth(coll) {
  const xs = Array.from((0, _sequence2.default)(coll));

  return xs[Math.floor(Math.random() * xs.length)];
}