'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = replace;

var _map = require('./map');

var _map2 = _interopRequireDefault(_map);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合の要素をマップの値で置き換えます。
 *
 * @param {Map} smap - 要素の置き換え規則のマップ
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator} 置き換えられた集合のイテレーター
 *
 * @example
 * replace(new Map([[0, 'zero'], [1, 'one'], [2, 'two']]), range(3));  // ['zero', 'one', 'two']のイテレーター
 */
function replace(smap, coll) {
  return (0, _map2.default)(x => smap.get(x), coll);
}