'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = rest;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合の2番目の要素から最後の要素までのイテレーターを返します。集合の要素数が2未満の場合は、空集合のイテレーターを返します。
 *
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator} 集合の2番目の要素から最後の要素までのイテレーター
 */
function rest(coll) {
  const iter = (0, _sequence2.default)(coll);

  iter.next();

  return iter;
}