'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = rseq;

var _seq = require('./seq');

var _seq2 = _interopRequireDefault(_seq);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 配列を逆順に辿るイテレーターを返します。
 *
 * @param {*[]} coll - 配列
 *
 * @return {iterator | null} イテレーター。配列が空の場合はnull
 */
function rseq(coll) {
  if (!Array.isArray(coll)) {
    throw 'Invalid arguments';
  }

  return (0, _seq2.default)(function* () {
    for (let i = coll.length - 1; i >= 0; --i) {
      yield coll[i];
    }
  }());
}