'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = seq;

var _cons = require('./cons');

var _cons2 = _interopRequireDefault(_cons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合からイテレーターを取得します。集合が空の場合はnullを返します。
 *
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator | null} イテレーター
 */
function seq(coll) {
  if (coll === null) {
    return null;
  }

  const iter = coll[Symbol.iterator]();

  const next = iter.next();
  if (next.done) {
    return null;
  }

  return (0, _cons2.default)(next.value, iter);
}