'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = sortBy;

var _sort = require('./sort');

var _sort2 = _interopRequireDefault(_sort);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 関数の戻り値でソートします。
 *
 * @param {*[]} args - [keyfn, comp, coll]か[keyfn, coll]。compが省略された場合は<演算子。
 *
 * @return {iterator} ソートされた集合のイテレーター
 *
 * @example
 * sortBy(x => x.getAge(), xs);  // 年齢順でソート
 */
function sortBy(...args) {
  const [keyfn, comp, coll] = (() => {
    switch (args.length) {
      case 0:
        throw 'Invalid arguments';

      case 1:
        throw 'Invalid arguments';

      case 2:
        return [args[0], (x, y) => x < y, args[1]];

      default:
        return args;
    }
  })();

  return (0, _sort2.default)((x, y) => comp(keyfn(x), keyfn(y)), coll);
}