'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = splitAt;

var _drop = require('./drop');

var _drop2 = _interopRequireDefault(_drop);

var _juxt = require('./juxt');

var _juxt2 = _interopRequireDefault(_juxt);

var _partial = require('./partial');

var _partial2 = _interopRequireDefault(_partial);

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

var _take = require('./take');

var _take2 = _interopRequireDefault(_take);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 指定した箇所で集合を分割します。
 *
 * @param {number} n - 分割する場所
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator[]} 分割された集合のイテレーターの配列
 *
 * @example
 * splitAt(2, [1, 2, 3, 4, 5]);  // [[1, 2]のイテレーター, [3, 4, 5]のイテレーター]
 */
function splitAt(n, coll) {
  return (0, _juxt2.default)((0, _partial2.default)(_take2.default, n), (0, _partial2.default)(_drop2.default, n))((0, _sequence2.default)(coll));
}