'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = splitWith;

var _dropWhile = require('./dropWhile');

var _dropWhile2 = _interopRequireDefault(_dropWhile);

var _juxt = require('./juxt');

var _juxt2 = _interopRequireDefault(_juxt);

var _partial = require('./partial');

var _partial2 = _interopRequireDefault(_partial);

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

var _takeWhile = require('./takeWhile');

var _takeWhile2 = _interopRequireDefault(_takeWhile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 先頭から続く指定した条件を満たす要素の集合tと、そうでない要素の集合に分割します。[takeWhile(pred, coll), dropWhile(pred, coll)]です。
 *
 * @param {function} pred - 条件
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator[]} 分割された集合のイテレーターの配列
 *
 * @example
 * splitWith(x => x < 3, [1, 2, 3, 2, 1]);  // [[1, 2]のイテレーター, [3, 2, 1]のイテレーター]
 */
function splitWith(pred, coll) {
  return (0, _juxt2.default)((0, _partial2.default)(_takeWhile2.default, pred), (0, _partial2.default)(_dropWhile2.default, pred))((0, _sequence2.default)(coll));
}