'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = takeLast;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 集合の末尾n個の要素のイテレーターを返します。
 *
 * @param {number} n - 取得する要素の数
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator} 末尾n個の要素の集合のイテレーター
 *
 * @example
 * takeLast(3, range(10));  // [7, 8, 9]のイテレーター
 */
function takeLast(n, coll) {
  const xs = [];

  for (const x of (0, _sequence2.default)(coll)) {
    xs.push(x);

    if (xs.length > n) {
      xs.shift();
    }
  }

  return (0, _sequence2.default)(xs);
}