'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = takeNth;

var _sequence = require('./sequence');

var _sequence2 = _interopRequireDefault(_sequence);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * n個単位に要素を抽出した集合のイテレーターを返します。
 *
 * @param {number} n - 取得する要素の場所
 * @param {*[] | iterator | null} coll - 集合
 *
 * @return {iterator} n番目の要素、n * 2番目の要素、n * 3番目の要素...の集合のイテレーター
 *
 * @example
 * takeNth(2, range());  [0, 2, 4, 6, 8, 10...]のイテレーター
 */
function* takeNth(n, coll) {
  let i = 0;

  for (const x of (0, _sequence2.default)(coll)) {
    if (i++ % n === 0) {
      yield x;
    }
  }
}